<i18n>
{
  "fr": {
    "label-1": "La documentation",
    "label-2": "La méthodologie",
    "label-3": "Présentation",
    "label-4": "Facteurs d'émissions (FE)",
    "label-5": "Mise à jour des FE",
    "label-6": "Méthodes de calculs",
    "label-7": "Bilan Carbone©",
    "label-8": "Aide",
    "label-9": "Notes",
    "label-10": "Mode d'emploi",
    "label-12": "Fichier Missions",
    "label-13": "Protection des données",
    "label-14": "L'équipe",
    "label-15": "L'équipe de développement",
    "label-16": "Remerciements",
    "label-17": "Les données",
    "label-18": "Introduction",
    "label-19": "Le périmètre",
    "label-20": "Les bâtiments",
    "label-21": "Matériel informatique",
    "label-22": "Les véhicules",
    "label-23": "Les missions",
    "label-24": "Dpts domicile / travail",
    "label-25": "Le bilan réglementaire",
    "label-26": "Empreinte carbone & soumission",
    "label-27": "Soumission des données",
    "label-28": "Les résultats",
    "label-29": "Les Achats",
    "label-30": "Fichier achats",
    "label-30-1": "Webinaires",
    "label-31": "Les données",
    "label-32": "BGES",
    "label-33": "Ajouter un BGES"
  },
  "en": {
    "label-1": "Documentation",
    "label-2": "Methodology",
    "label-3": "Presentation",
    "label-4": "Emission factors (EF)",
    "label-5": "EF update",
    "label-6": "Calculation methods",
    "label-7": "Bilan Carbone©",
    "label-8": "Help",
    "label-9": "Notes",
    "label-10": "User guide",
    "label-12": "Business trip files",
    "label-13": "Data protection",
    "label-14": "The team",
    "label-15": "The development team",
    "label-16": "Acknowledgments",
    "label-17": "Data",
    "label-18": "Introduction",
    "label-19": "Boundaries",
    "label-20": "Buildings",
    "label-21": "Digital devices",
    "label-22": "Vehicles",
    "label-23": "Business travel",
    "label-24": "Commuting",
    "label-25": "Regulatory inventory",
    "label-26": "Carbon footprint & submission",
    "label-27": "Data submission",
    "label-28": "Results",
    "label-29": "Purchases",
    "label-30": "Purchases file",
    "label-30-1": "Webinars",
    "label-31": "Datasets",
    "label-32": "GHGI",
    "label-33": "Add a GHGI"
  }
}
</i18n>

<template>
  <section class="hero is-default is-bold">
    <div class="hero-body">
      <div class="container">
        <div class="columns">
          <div class="column is-one-quarter">
            <b-field v-if="isAuthenticated && routeParam && activeModule!='emissions-factors'">
              <div class="control is-expanded is-clearfix">
                <b-dropdown
                  :expanded="true"
                  aria-role="list"
                >
                  <template #trigger="{ active }">
                    <b-button
                      expanded
                      :label="buttonLabel"
                      type="is-primary"
                      :icon-left="buttonIcon"
                      :icon-right="active ? 'caret-up' : 'caret-down'"
                    />
                  </template>
                  <b-dropdown-item
                    v-for="ghgi in allGHGI" :key="ghgi.id"
                    aria-role="listitem"
                    @click="loadGHGI(ghgi.id)"
                  >
                    <b-icon icon="calendar" /> {{ $t('label-32') }} {{ ghgi.year }}
                  </b-dropdown-item>
                  <b-dropdown-item
                    aria-role="listitem"
                    @click="createGHGI()"
                  >
                    <b-icon icon="plus" /> {{ $t('label-33') }}
                  </b-dropdown-item>
                </b-dropdown>
              </div>
            </b-field>
            <b-menu>
              <b-menu-list :label="$t('label-1')" v-if="activeModule=='emissions-factors'">
                <b-menu-item
                  class="menubackitem"
                  @click="activate('methodology')"
                  :active="activeModule==='methodology'"
                >
                  <template slot="label">
                    <nav class="level">
                      <div class="level-left">
                        <div class="level-item" style="color:#fff">
                          <b-icon icon="arrow-left"></b-icon>
                        </div>
                      </div>
                    </nav>
                  </template>
                </b-menu-item>
              </b-menu-list>
              <b-menu-list :label="$t('label-1')" v-if="activeModule!='emissions-factors'">
                <b-menu-item
                  :active="activeModule==='methodology'||activeModule==='calculating-methods'||activeModule==='emissions-factors'"
                  :expanded="activeModule==='methodology'||activeModule==='calculating-methods'||activeModule==='update-emissions-factors'||activeModule==='emissions-factors'||activeModule==='ademe-diff'"
                  @click="activate('methodology')">
                  <template slot="label" slot-scope="props">
                    <b-icon icon="book"></b-icon>
                    {{ $t('label-2') }}
                    <b-icon
                      class="is-pulled-right"
                      :icon="props.expanded ? 'caret-down' : 'caret-up'">
                    </b-icon>
                  </template>
                  <b-menu-item
                    :active="activeModule==='methodology'"
                    @click="activate('methodology')"
                  >
                    <template slot="label">
                      <nav class="level">
                        <div class="level-left">
                          <div class="level-item">
                            <b-icon icon="info"></b-icon>
                            {{ $t('label-3') }}
                          </div>
                        </div>
                      </nav>
                    </template>
                  </b-menu-item>
                  <b-menu-item
                    @click="activate('emissions-factors')"
                    :active="activeModule==='emissions-factors'"
                  >
                    <template slot="label">
                      <nav class="level">
                        <div class="level-left">
                          <div class="level-item">
                            <b-icon icon="cloud"></b-icon>
                            {{ $t('label-4') }}
                          </div>
                        </div>
                      </nav>
                    </template>
                  </b-menu-item>
                  <b-menu-item
                    @click="activate('update-emissions-factors')"
                    :active="activeModule==='update-emissions-factors'"
                  >
                    <template slot="label">
                      <nav class="level">
                        <div class="level-left">
                          <div class="level-item">
                            <b-icon icon="refresh"></b-icon>
                            {{ $t('label-5') }}
                          </div>
                        </div>
                      </nav>
                    </template>
                  </b-menu-item>
                  <b-menu-item
                    @click="activate('calculating-methods')"
                    :active="activeModule==='calculating-methods'"
                  >
                    <template slot="label">
                      <nav class="level">
                        <div class="level-left">
                          <div class="level-item">
                            <b-icon icon="cog"></b-icon>
                            {{ $t('label-6') }}
                          </div>
                        </div>
                      </nav>
                    </template>
                  </b-menu-item>
                  <b-menu-item
                    :active="activeModule==='ademe-diff'"
                    @click="activate('ademe-diff')"
                  >
                    <template slot="label">
                      <nav class="level">
                        <div class="level-left">
                          <div class="level-item">
                            <b-icon icon="chain-broken"></b-icon>
                            {{ $t('label-7') }}
                          </div>
                        </div>
                      </nav>
                    </template>
                  </b-menu-item>
                </b-menu-item>
                <b-menu-item
                  :active="activeModule==='notes'||activeModule==='manual'||activeModule==='travels-file-format'||activeModule==='purchases-file-extraction'||activeModule==='webinar'||activeModule==='ges-data'"
                  :expanded="activeModule==='notes'||activeModule==='manual'||activeModule==='travels-file-format'||activeModule==='purchases-file-extraction'||activeModule==='webinar'||activeModule==='ges-data'"
                  @click="activate('notes')">
                  <template slot="label" slot-scope="props">
                    <b-icon icon="life-ring"></b-icon>
                    {{ $t('label-8') }}
                    <b-icon
                      class="is-pulled-right"
                      :icon="props.expanded ? 'caret-down' : 'caret-up'">
                    </b-icon>
                  </template>
                  <b-menu-item
                    :active="activeModule==='notes'"
                    @click="activate('notes')"
                  >
                    <template slot="label">
                      <nav class="level">
                        <div class="level-left">
                          <div class="level-item">
                            <b-icon icon="warning"></b-icon>
                            {{ $t('label-9') }}
                          </div>
                        </div>
                      </nav>
                    </template>
                  </b-menu-item>
                  <b-menu-item
                    :active="activeModule==='ges-data'"
                    @click="activate('ges-data')"
                  >
                    <template slot="label">
                      <nav class="level">
                        <div class="level-left">
                          <div class="level-item">
                            <b-icon icon="table"></b-icon>
                            {{ $t('label-31') }}
                          </div>
                        </div>
                      </nav>
                    </template>
                  </b-menu-item>
                  <b-menu-item
                    :active="activeModule==='manual'"
                    @click="activate('manual')"
                  >
                    <template slot="label">
                      <nav class="level">
                        <div class="level-left">
                          <div class="level-item">
                            <b-icon icon="book"></b-icon>
                            {{ $t('label-10') }}
                          </div>
                        </div>
                      </nav>
                    </template>
                  </b-menu-item>
                  <b-menu-item
                    :active="activeModule==='travels-file-format'"
                    @click="activate('travels-file-format')"
                  >
                    <template slot="label">
                      <nav class="level">
                        <div class="level-left">
                          <div class="level-item">
                            <b-icon icon="file-text"></b-icon>
                            {{ $t('label-12') }}
                          </div>
                        </div>
                      </nav>
                    </template>
                  </b-menu-item>
                  <b-menu-item
                    :active="activeModule==='purchases-file-extraction'"
                    @click="activate('purchases-file-extraction')"
                  >
                    <template slot="label">
                      <nav class="level">
                        <div class="level-left">
                          <div class="level-item">
                            <b-icon icon="file-text"></b-icon>
                            {{ $t('label-30') }}
                          </div>
                        </div>
                      </nav>
                    </template>
                  </b-menu-item>
                  <b-menu-item
                    :active="activeModule==='webinar'"
                    @click="activate('webinar')"
                  >
                    <template slot="label">
                      <nav class="level">
                        <div class="level-left">
                          <div class="level-item">
                            <b-icon icon="play-circle-o"></b-icon>
                            {{ $t('label-30-1') }}
                          </div>
                        </div>
                      </nav>
                    </template>
                  </b-menu-item>
                </b-menu-item>
                <b-menu-item
                  @click="activate('data-protection')"
                  :active="activeModule==='data-protection'"
                >
                  <template slot="label">
                    <nav class="level">
                      <div class="level-left">
                        <div class="level-item">
                          <b-icon icon="shield"></b-icon>
                          {{ $t('label-13') }}
                        </div>
                      </div>
                    </nav>
                  </template>
                </b-menu-item>
                <b-menu-item
                  :active="activeModule==='team'||activeModule==='thanks'"
                  :expanded="activeModule==='team'||activeModule==='thanks'"
                  @click="activate('team')">
                  <template slot="label" slot-scope="props">
                    <b-icon icon="users"></b-icon>
                    {{ $t('label-14') }} <em>GES 1point5</em>
                    <b-icon
                      class="is-pulled-right"
                      :icon="props.expanded ? 'caret-down' : 'caret-up'">
                    </b-icon>
                  </template>
                   <b-menu-item
                    :active="activeModule==='team'"
                    @click="activate('team')"
                  >
                    <template slot="label">
                      <nav class="level">
                        <div class="level-left">
                          <div class="level-item">
                            <b-icon icon="keyboard-o"></b-icon>
                            {{ $t('label-15') }}
                          </div>
                        </div>
                      </nav>
                    </template>
                  </b-menu-item>
                  <b-menu-item
                    :active="activeModule==='thanks'"
                    @click="activate('thanks')"
                  >
                    <template slot="label">
                      <nav class="level">
                        <div class="level-left">
                          <div class="level-item">
                            <b-icon icon="thumbs-o-up"></b-icon>
                            {{ $t('label-16') }}
                          </div>
                        </div>
                      </nav>
                    </template>
                  </b-menu-item>
                </b-menu-item>
              </b-menu-list>
              <b-menu-list :label="$t('label-17')" v-if="activeModule!='emissions-factors'">
                <b-menu-item
                  @click="activate('introduction')"
                  :active="activeModule==='introduction'"
                >
                  <template slot="label">
                    <nav class="level">
                      <div class="level-left">
                        <div class="level-item">
                          <b-icon icon="info"></b-icon>
                          {{ $t('label-18') }}
                        </div>
                      </div>
                    </nav>
                  </template>
                </b-menu-item>
                <b-menu-item
                  @click="activate('boundaries')"
                  :active="activeModule==='boundaries'"
                  :disabled="boundariesIsDisabled"
                >
                  <template slot="label">
                    <nav class="level">
                      <div class="level-left">
                        <div class="level-item">
                          <b-icon icon="square"></b-icon>
                          {{ $t('label-19') }}
                        </div>
                      </div>
                      <div class="level-right">
                        <div class="level-item">
                          <b-tag rounded :type="tagType(boundaries.isModified)" v-show="boundaries.isValid|boundaries.isModified">
                            <b-icon :icon="validSavedIcon"></b-icon>
                          </b-tag>
                        </div>
                      </div>
                    </nav>
                  </template>
                </b-menu-item>
                <b-menu-item
                  @click="activate('buildings')"
                  :active="activeModule==='buildings'"
                  :disabled="dataIsDisabled"
                >
                  <template slot="label">
                    <nav class="level">
                      <div class="level-left">
                        <div class="level-item">
                          <b-icon icon="building"></b-icon>
                          {{ $t('label-20') }}
                        </div>
                      </div>
                      <div class="level-right">
                        <div class="level-item">
                          <b-tag rounded :type="tagType(buildings.isModified)" v-if="buildings.isValid">
                            <b-icon :icon="validSavedIcon"></b-icon>
                          </b-tag>
                        </div>
                      </div>
                    </nav>
                  </template>
                </b-menu-item>
                <b-menu-item
                  @click="activate('purchases')"
                  :active="activeModule==='purchases'"
                  :disabled="dataIsDisabled"
                >
                  <template slot="label">
                    <nav class="level">
                      <div class="level-left">
                        <div class="level-item">
                          <b-icon icon="eur"></b-icon>
                          {{ $t('label-29') }}
                        </div>
                      </div>
                      <div class="level-right">
                        <div class="level-item">
                          <b-taglist>
                            <b-tag rounded type="is-info">
                              {{ $t('early.access') }}
                            </b-tag>
                            <b-tag rounded :type="tagType(purchases.isModified)" v-if="purchases.isValid">
                              <b-icon :icon="validSavedIcon"></b-icon>
                            </b-tag>
                          </b-taglist>
                        </div>
                      </div>
                    </nav>
                  </template>
                </b-menu-item>
                <b-menu-item
                  @click="activate('computer-devices')"
                  :active="activeModule==='computer-devices'"
                  :disabled="dataIsDisabled"
                >
                  <template slot="label">
                    <nav class="level">
                      <div class="level-left">
                        <div class="level-item">
                          <b-icon icon="desktop"></b-icon>
                          {{ $t('label-21') }}
                        </div>
                      </div>
                      <div class="level-right">
                        <div class="level-item">
                          <b-tag rounded :type="tagType(computerDevices.isModified)" v-if="computerDevices.isValid">
                            <b-icon :icon="validSavedIcon"></b-icon>
                          </b-tag>
                        </div>
                      </div>
                    </nav>
                  </template>
                </b-menu-item>
                <b-menu-item
                  @click="activate('vehicles')"
                  :active="activeModule==='vehicles'"
                  :disabled="dataIsDisabled"
                >
                  <template slot="label">
                    <nav class="level">
                      <div class="level-left">
                        <div class="level-item">
                          <b-icon icon="car"></b-icon>
                          {{ $t('label-22') }}
                        </div>
                      </div>
                      <div class="level-right">
                        <div class="level-item">
                          <b-tag rounded :type="tagType(vehicles.isModified)" v-if="vehicles.isValid">
                            <b-icon :icon="validSavedIcon"></b-icon>
                          </b-tag>
                        </div>
                      </div>
                    </nav>
                  </template>
                </b-menu-item>
                <b-menu-item
                  @click="activate('travels')"
                  :active="activeModule==='travels'"
                  :disabled="dataIsDisabled"
                >
                  <template slot="label">
                    <nav class="level">
                      <div class="level-left">
                        <div class="level-item">
                          <b-icon icon="train"></b-icon>
                          {{ $t('label-23') }}
                        </div>
                      </div>
                      <div class="level-right">
                        <div class="level-item">
                          <b-tag rounded :type="tagType(travels.isModified)" v-if="travels.isValid">
                            <b-icon :icon="validSavedIcon"></b-icon>
                          </b-tag>
                        </div>
                      </div>
                    </nav>
                  </template>
                </b-menu-item>
                <b-menu-item
                  @click="activate('commutes')"
                  :active="activeModule==='commutes'"
                  :disabled="dataIsDisabled"
                >
                  <template slot="label">
                    <nav class="level">
                      <div class="level-left">
                        <div class="level-item">
                          <b-icon icon="bicycle"></b-icon>
                          {{ $t('label-24') }}
                        </div>
                      </div>
                      <div class="level-right">
                        <div class="level-item">
                          <b-taglist>
                            <b-tag rounded :type="tagType(commutes.isModified)" v-if="commutes.isValid">
                              <b-icon :icon="validSavedIcon"></b-icon>
                            </b-tag>
                          </b-taglist>
                        </div>
                      </div>
                    </nav>
                  </template>
                </b-menu-item>
              </b-menu-list>
              <b-menu-list :label="$t('label-28')" v-if="activeModule!='emissions-factors'">
                <b-menu-item
                  @click="activate('regulatory-inventory')"
                  :active="activeModule==='regulatory-inventory'"
                  :disabled="reglementaireIsDisabled"
                >
                  <template slot="label">
                    <nav class="level">
                      <div class="level-left">
                        <div class="level-item">
                          <b-icon icon="bank"></b-icon>
                          {{ $t('label-25') }}
                        </div>
                      </div>
                    </nav>
                  </template>
                </b-menu-item>
                <b-menu-item
                  @click="activate('synthese-empreinte')"
                  :active="activeModule==='synthese-empreinte'"
                  :disabled="reglementaireIsDisabled"
                >
                  <template slot="label">
                    <nav class="level">
                      <div class="level-left">
                        <div class="level-item">
                          <b-icon icon="paw"></b-icon>
                          {{ $t('label-26') }}
                        </div>
                      </div>
                    </nav>
                  </template>
                </b-menu-item>
              </b-menu-list>
            </b-menu>
          </div>
          <div class="column">
            <introduction @invalid="invalidateIntroduction" @valid="validateIntroduction" v-if="activeModule==='introduction'"/>
            <methodology v-if="activeModule==='methodology'"/>
            <ademe-diff v-if="activeModule==='ademe-diff'"/>
            <notes :header="true" v-if="activeModule==='notes'"/>
            <manual :header="true" v-if="activeModule==='manual'"/>
            <calculating-methods v-if="activeModule==='calculating-methods'"/>
            <emissions-factors v-if="activeModule==='emissions-factors'"/>
            <update-emissions-factors v-if="activeModule==='update-emissions-factors'"/>
            <travels-file-format :header="true" v-if="activeModule==='travels-file-format'"/>
            <purchases-file-extraction :header="true" v-if="activeModule==='purchases-file-extraction'"/>
            <webinar :header="true" v-if="activeModule==='webinar'"/>
            <data-protection v-if="activeModule==='data-protection'"/>
            <team v-if="activeModule==='team'"/>
            <thanks v-if="activeModule==='thanks'"/>
            <boundaries v-model="boundaries" v-if="activeModule==='boundaries'"/>
            <buildings v-model="buildings" v-if="activeModule==='buildings'"/>
            <vehicles v-model="vehicles" v-if="activeModule==='vehicles'"/>
            <travels v-model="travels" v-show="activeModule==='travels'"/>
            <purchases ref="purchases" v-model="purchases" v-show="activeModule==='purchases'"/>
            <commutes v-model="commutes" v-show="activeModule==='commutes'"/>
            <computer-devices v-model="computerDevices" v-show="activeModule==='computer-devices'"/>
            <regulatory-inventory v-if="activeModule==='regulatory-inventory'"/>
            <synthese-empreinte v-if="activeModule==='synthese-empreinte'"/>
            <ges-data v-if="activeModule==='ges-data'"/>
          </div>
        </div>
      </div>
    </div>
  </section>
</template>

<script>

import { mapGetters } from 'vuex'
import Travels from '@/components/carbon/forms/Travels.vue'
import Commutes from '@/components/carbon/forms/Commutes.vue'

export default {
  name: 'GES1point5',
  components: {
    'methodology': () => import('@/components/carbon/docs/Methodology.vue'),
    'notes': () => import('@/components/carbon/docs/Notes.vue'),
    'manual': () => import('@/components/carbon/docs/Manual.vue'),
    'calculating-methods': () => import('@/components/carbon/docs/CalculatingMethods.vue'),
    'emissions-factors': () => import('@/components/carbon/docs/EmissionsFactors.vue'),
    'update-emissions-factors': () => import('@/components/carbon/docs/UpdateEmissionsFactors.vue'),
    'travels-file-format': () => import('@/components/carbon/docs/TravelsFileFormat.vue'),
    'purchases-file-extraction': () => import('@/components/carbon/docs/PurchasesFileExtraction.vue'),
    'webinar': () => import('@/components/carbon/docs/Webinar.vue'),
    'data-protection': () => import('@/components/carbon/docs/DataProtection.vue'),
    'ges-data': () => import('@/components/carbon/docs/GES1point5Data.vue'),
    'ademe-diff': () => import('@/components/carbon/docs/ADEMEDiff.vue'),
    'team': () => import('@/components/carbon/docs/Team.vue'),
    'thanks': () => import('@/components/carbon/docs/Thanks.vue'),
    'introduction': () => import('@/components/carbon/forms/Introduction.vue'),
    'purchases': () => import('@/components/carbon/forms/Purchases.vue'),
    'boundaries': () => import('@/components/carbon/forms/Boundaries.vue'),
    'buildings': () => import('@/components/carbon/forms/Buildings.vue'),
    'vehicles': () => import('@/components/carbon/forms/Vehicles.vue'),
    'travels': Travels,
    'commutes': Commutes,
    'computer-devices': () => import('@/components/carbon/forms/ComputerDevices.vue'),
    'regulatory-inventory': () => import('@/components/carbon/results/RegulatoryInventory.vue'),
    'synthese-empreinte': () => import('@/components/carbon/results/SyntheseEmpreinte.vue')
  },
  data () {
    return {
      isNewGHGI: true,
      hasLaboratory: false
    }
  },
  computed: {
    ...mapGetters('authentication', ['isAuthenticated']),
    activeModule: function () {
      return this.$store.getters['introduction/activeModule']
    },
    introduction: function () {
      return this.$store.getters['introduction/module']
    },
    boundaries: function () {
      return this.$store.getters['ghgi/module']
    },
    ghgiYear: function () {
      return this.$store.getters['ghgi/item']['year']
    },
    buildings: function () {
      return this.$store.getters['buildings/module']
    },
    vehicles: function () {
      return this.$store.getters['vehicles/module']
    },
    travels: function () {
      return this.$store.getters['travels/module']
    },
    commutes: function () {
      return this.$store.getters['commutes/module']
    },
    computerDevices: function () {
      return this.$store.getters['computerdevices/module']
    },
    purchases: function () {
      return this.$store.getters['purchases/module']
    },
    validSavedIcon: function () {
      let icon = null
      if (this.isAuthenticated) {
        icon = 'save'
      } else {
        icon = 'check'
      }
      return icon
    },
    buttonLabel: function () {
      if (this.ghgiYear) {
        return this.$t('label-32') + ' ' + this.ghgiYear
      } else {
        return this.$t('label-33')
      }
    },
    buttonIcon: function () {
      if (this.ghgiYear) {
        return 'calendar'
      } else {
        return 'plus'
      }
    },
    routeParam: function () {
      return this.$route.params.id
    },
    allGHGI: function () {
      return this.$store.getters['admin/allGHGI']
    },
    dataIsDisabled: function () {
      let isDisabled = false
      if (this.introduction.isValid) {
        isDisabled = !this.boundaries.isValid && !this.boundaries.isModified
      } else {
        isDisabled = true
      }
      return isDisabled
    },
    boundariesIsDisabled: function () {
      let isDisabled = true
      if (this.isAuthenticated && this.hasLaboratory && !this.isNewGHGI) {
        isDisabled = false
      } else if (this.isAuthenticated && this.hasLaboratory && this.introduction.isValid) {
        isDisabled = false
      } else if (!this.isAuthenticated && this.introduction.isValid) {
        isDisabled = false
      }
      return isDisabled
    },
    reglementaireIsDisabled: function () {
      return !this.buildings.isValid && !this.vehicles.isValid && !this.travels.isValid && !this.commutes.isValid && !this.computerDevices.isValid && !this.purchases.isValid
    }
  },
  watch: {
    routeParam: function () {
      this.parameterInitState()
    }
  },
  methods: {
    tagType: function (isModified) {
      let tagType = 'is-success'
      if (isModified) {
        tagType = 'is-danger'
      }
      return tagType
    },
    loadGHGI (ghgiID) {
      const loadingComponent = this.$buefy.loading.open({
        container: null
      })
      this.$store.dispatch('ghgi/set', ghgiID)
        .then(data => {
          loadingComponent.close()
          this.$router.push('/ges-1point5/' + ghgiID)
        })
        .catch((erreur) => {
          loadingComponent.close()
        })
    },
    createGHGI () {
      this.$store.dispatch('ghgi/resetGHGI')
      this.$router.push('/ges-1point5/0')
    },
    validateIntroduction: function () {
      this.$store.commit('introduction/ISVALID', true)
      if (!this.isAuthenticated) {
        this.activate('boundaries')
      } else {
        if (this.hasLaboratory) {
          this.activate('boundaries')
        }
      }
    },
    invalidateIntroduction: function () {
      this.$store.commit('introduction/ISVALID', false)
      this.$store.commit('ghgi/RESET_STATE')
      this.$store.commit('vehicles/RESET_STATE')
      this.$store.commit('buildings/RESET_STATE')
      this.$store.commit('commutes/RESET_STATE')
      this.$store.commit('travels/RESET_STATE')
      this.$store.commit('computerdevices/RESET_STATE')
      this.$store.commit('purchases/RESET_STATE')
    },
    activate: function (module) {
      this.$store.commit('introduction/SET_ACTIVE_MODULE', module)
      if (module === 'purchases') {
        this.$refs.purchases.forceComputation()
      }
      this.$store.commit('computerdevices/ISACTIVE', module === 'computer-devices')
    },
    parameterInitState: function () {
      this.$store.commit('introduction/RESET_MODULE')
      this.$store.commit('ghgi/RESET_MODULE')
      this.$store.commit('vehicles/RESET_MODULE')
      this.$store.commit('buildings/RESET_MODULE')
      this.$store.commit('commutes/RESET_MODULE')
      this.$store.commit('travels/RESET_MODULE')
      this.$store.commit('computerdevices/RESET_MODULE')
      this.$store.commit('purchases/RESET_MODULE')
      if (this.routeParam) {
        if (this.routeParam === '0') {
          this.activate('introduction')
          this.isNewGHGI = true
        } else {
          this.activate('boundaries')
          this.isNewGHGI = false
          this.$store.commit('introduction/ISVALID', true)
          this.$store.commit('ghgi/ISVALID', true)
          this.$store.commit('vehicles/ISVALID', this.$store.getters['vehicles/hasItems'])
          this.$store.commit('buildings/ISVALID', this.$store.getters['buildings/hasItems'])
          this.$store.commit('travels/ISVALID', this.$store.getters['travels/hasItems'])
          this.$store.commit('commutes/ISVALID', this.$store.getters['commutes/hasItems'])
          this.$store.commit('computerdevices/ISVALID', this.$store.getters['computerdevices/hasItems'])
          this.$store.commit('purchases/ISVALID', this.$store.getters['purchases/hasItems'])
        }
      }
    }
  },
  mounted () {
    if (this.isAuthenticated) {
      const loadingComponent = this.$buefy.loading.open({
        container: null
      })
      this.$store.dispatch('api/getLaboratory')
        .then(data => {
          if (data) {
            this.hasLaboratory = (data.id !== null)
            if (this.hasLaboratory) {
              this.$store.dispatch('admin/getAllGHGI')
                .then(data => {
                  if (this.routeParam) {
                    if (this.routeParam !== '0') {
                      this.$store.dispatch('ghgi/set', parseInt(this.routeParam))
                        .then(data => {
                          loadingComponent.close()
                          this.parameterInitState()
                        })
                    } else {
                      loadingComponent.close()
                      this.parameterInitState()
                    }
                  } else {
                    loadingComponent.close()
                    this.parameterInitState()
                  }
                }).catch((erreur) => {
                  loadingComponent.close()
                })
            }
          } else {
            loadingComponent.close()
          }
        })
        .catch((erreur) => {
          loadingComponent.close()
          this.hasLaboratory = false
        })
    }
  }
}
</script>

<style>
  .menu-list a.is-active {
    background-color: rgba(52, 59, 64, 0.7) !important;
    color: white;
  }
  .menubackitem {
    max-width: 50px;
    border-radius:5px;
    background-color:rgb(70, 128, 223, 1);
  }
  .menubackitem :hover {
    border-radius:5px;
    background-color:rgb(70, 128, 223, 1) !important;
    cursor: pointer;
  }
</style>

<style scoped>
  .dropdown .dropdown-menu .has-link a, a.dropdown-item, button.dropdown-item {
    text-align: center;
  }
</style>
